unit U_GetDllForm;

interface

uses
  Windows, Messages, forms, OleCtnrs, DateUtils, SysUtils, ADODB, dxCore,
  ActiveX;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd; export; stdcall;

function ConnData(): Boolean;

implementation

uses
  U_DataLink, U_MachineArea, U_WeiXiuList, U_MachineManage, U_MachineManageJN,U_MachineManageJNGL,
  U_JNPRT,U_JNPRTList,U_KWManage;

       /////////////////////////////////////////////////////////////////
      //         功能说明:取Dll中得窗体                              //
     //        参数说明：App>>调用应用程序；                        //
    //                 FormH>>调用窗口句柄 ；                      //
   //                 FormID>>窗口号;                             //
  //                 Language>>语言种类;                         //
 //                 WinStyle>>窗口类型；                        //
/////////////////////////////////////////////////////////////////
function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd;
var
  mnewHandle: hwnd;
  mstyle: TFormStyle;     // 0:子窗口; 1：普通窗口
  mstate: TWindowState;
  mborderstyle: TFormBorderStyle;
begin
  mnewHandle := 0;
  DName := PChar(GName);
  DCode := PChar(GCode);
  DdataBase := DataBase;
  DTitCaption := Title;
  DParameters1 := Parameters1;
  DParameters2 := Parameters2;
  DParameters3 := Parameters3;
  DParameters4 := Parameters4;
  DParameters5 := Parameters5;
  DParameters6 := Parameters6;
  DParameters7 := Parameters7;
  DParameters8 := Parameters8;
  DParameters9 := Parameters9;
  DParameters10 := Parameters10;

  MainApplication := App;
  DCurHandle := FormH;
  IsDelphiLanguage := Language;

  Application := TApplication(App);
  DCurHandle := 0;


   //赋值链接字符串
  SetLength(server, 255);
  SetLength(dtbase, 255);
  SetLength(user, 255);
  SetLength(pswd, 255);
  if Trim(DataBaseStr) = '' then
  begin
    server := '139.196.189.214,7781';
//  server := '.';
    dtbase := 'yongjindata';
    user := 'yifusa';
    pswd := 'rightsoft@123';
//  pswd := 'rightsoft';
    DConString := 'Provider=SQLOLEDB.1;Password=' + pswd + ';Persist Security Info=True;User ID=' + user + ';Initial Catalog=' + dtbase + ';Data Source=' + server;
//

   //DParameters1:='高权限';   //高权限
   //DParameters3:='1';
  end
  else
  begin
    DConString := DataBaseStr;
  end;

  if not ConnData() then
  begin
    result := 0;
    exit;
  end;

   // 定义窗口类型 、状态
  if WinStyle = 0 then
  begin
    mstyle := fsMDIChild;
    mstate := wsMaximized;
    mborderstyle := bsSizeable;
  end
  else
  begin
    mstyle := fsNormal;
    mstate := wsNormal;
    mborderstyle := bsSizeable;
  end;
  /////////////////////
  //调用子模块窗口
  case FormID of
    200:  //加捻机台管理
      begin
        if frmMachineManageJNGL = nil then
        begin
          frmMachineManageJNGL := TfrmMachineManageJNGL.Create(application.MainForm);
          with frmMachineManageJNGL do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmMachineManageJNGL.BringToFront;
       //句柄
        mnewHandle := frmMachineManageJNGL.Handle;
      end;
    201:  //加捻机台绑定
      begin
        if frmMachineManageJN = nil then
        begin
          frmMachineManageJN := TfrmMachineManageJN.Create(application.MainForm);
          with frmMachineManageJN do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmMachineManageJN.BringToFront;
       //句柄
        mnewHandle := frmMachineManageJN.Handle;
      end;
    202:  //加捻标签打印
      begin
        if frmJNPRT = nil then
        begin
          frmJNPRT := TfrmJNPRT.Create(application.MainForm);
          with frmJNPRT do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmJNPRT.BringToFront;
       //句柄
        mnewHandle := frmJNPRT.Handle;
      end;
    203:  //加捻库存查询
      begin
        if frmJNPRTList = nil then
        begin
          frmJNPRTList := TfrmJNPRTList.Create(application.MainForm);
          with frmJNPRTList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmJNPRTList.BringToFront;
       //句柄
        mnewHandle := frmJNPRTList.Handle;
      end;
    111:  //机台看板
      begin
        if frmMachineArea = nil then
        begin
          frmMachineArea := TfrmMachineArea.Create(application.MainForm);
          with frmMachineArea do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmMachineArea.BringToFront;
       //句柄
        mnewHandle := frmMachineArea.Handle;
      end;
    101:  //机台管理
      begin
        if frmMachineManage = nil then
        begin
          frmMachineManage := TfrmMachineManage.Create(application.MainForm);
          with frmMachineManage do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmMachineManage.BringToFront;
       //句柄
        mnewHandle := frmMachineManage.Handle;
      end;
         106:  //库位管理
      begin
        if frmKWManage = nil then
        begin
          frmKWManage := TfrmKWManage.Create(application.MainForm);
          with frmKWManage do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmKWManage.BringToFront;
       //句柄
        mnewHandle := frmKWManage.Handle;
      end;
    121:  //维修记录
      begin
        if frmWeiXiuList = nil then
        begin
          frmWeiXiuList := TfrmWeiXiuList.Create(application.MainForm);
          with frmWeiXiuList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmWeiXiuList.BringToFront;
       //句柄
        mnewHandle := frmWeiXiuList.Handle;
      end;
  end;

  Result := mnewHandle;
  //NewDllApp := Application;
end;
//===========================================================
  //建立数据库连接池
//===========================================================

function ConnData(): Boolean;
begin
  if not Assigned(DataLink_Machine) then
    DataLink_Machine := TDataLink_Machine.Create(Application);
  try
    with DataLink_Machine.ADOLink do
    begin
      //if not Connected then
      begin
        Connected := false;
        ConnectionString := DConString;
        LoginPrompt := false;
        Connected := true;
      end;
    end;
    Result := true;
  except
    Result := false;
    application.MessageBox('数据库连接失败！', '错误', mb_Ok + MB_ICONERROR);
  end;

end;

initialization
  CoInitialize(nil);
  dxUnitsLoader.Initialize;

finalization
  DataLink_Machine.Free;
  application := NewDllApp;
  dxUnitsLoader.Finalize;

end.

